---
applyTo: "**"
name: mobiscroll-ui-jquery
description: |
  Mobiscroll jQuery patterns — .mobiscroll() plugin chain, event callbacks, dynamic
  updates, @mobiscroll/jquery imports. Invoked by mobiscroll-ui after framework detection.
  Do not auto-trigger — invoked by mobiscroll-ui only.
---

# Mobiscroll — jQuery Patterns

> This skill is loaded by `mobiscroll-ui`. If you arrived here directly, invoke
> `mobiscroll-ui` first to run environment detection and the mandatory schema lookup.

Package: `@mobiscroll/jquery`
CSS import: `import '@mobiscroll/jquery/dist/css/mobiscroll.min.css'`
Requires jQuery loaded before Mobiscroll.

## Initialization Pattern

```javascript
import $ from 'jquery';
import '@mobiscroll/jquery';

$('#my-calendar').mobiscroll().eventcalendar({
  data: events,
  view: { scheduler: { type: 'week' } },
  onEventCreate: function (args) {
    // handle
  }
});
```

## Key Conventions

- Initialization chains from a jQuery selector: `$('#el').mobiscroll().eventcalendar({...})`.
- The `.mobiscroll()` bridge call is required before the component method.
- Component methods are lowercase: `.eventcalendar()`, `.datepicker()`, `.select()`, `.popup()`.
- Event handlers are properties in the options object (same as vanilla JS).
- Instance access: `var inst = $('#el').mobiscroll().eventcalendar({...});` returns the
  Mobiscroll instance (not the jQuery object).

## Anti-Patterns

| WRONG | RIGHT |
|:---|:---|
| `$('#el').eventcalendar({...})` without `.mobiscroll()` | `$('#el').mobiscroll().eventcalendar({...})` |
| `mobiscroll.eventcalendar('#el', {...})` vanilla JS pattern | `$('#el').mobiscroll().eventcalendar({...})` jQuery pattern |
| `import { Eventcalendar } from '@mobiscroll/react'` | `import '@mobiscroll/jquery'` |
| React JSX or Angular templates | jQuery selector + plugin chain |
| `@mobiscroll/javascript` or `@mobiscroll/react` | `@mobiscroll/jquery` only |

## Event Handling

```javascript
$('#el').mobiscroll().eventcalendar({
  onEventClick: function (args) {
    console.log(args.event);
  }
});
```

## Dynamic Updates

```javascript
var inst = $('#el').mobiscroll().eventcalendar({...});
inst.setOptions({ data: newEvents });
```

## Custom Rendering

```javascript
// v6: renderSchedulerEvent (v5: renderScheduleEvent — deprecated in v6)
$('#el').mobiscroll().eventcalendar({
  renderSchedulerEvent: function (data) {
    return '<div class="custom-event">' + data.title + '</div>';
  }
});
```

> **v5 note:** `renderScheduleEvent` (without `r`) was the correct name in v5. In v6 it is
> deprecated — use `renderSchedulerEvent` instead. The same rename applies to all
> `*Content` variants.

Always verify available render options via `mcp__mobiscroll__getComponentSchema`.


---
applyTo: "**"
name: mobiscroll-ui-vue
description: |
  Mobiscroll Vue patterns — MbscEventcalendar components, Vue 3 Composition API, named
  slots, @mobiscroll/vue imports. Invoked by mobiscroll-ui after framework detection.
  Do not auto-trigger — invoked by mobiscroll-ui only.
---

# Mobiscroll — Vue Patterns

> This skill is loaded by `mobiscroll-ui`. If you arrived here directly, invoke
> `mobiscroll-ui` first to run environment detection and the mandatory schema lookup.

Package: `@mobiscroll/vue`
CSS import: `import '@mobiscroll/vue/dist/css/mobiscroll.min.css'`
**Vue 3 Composition API with `<script setup>` only** — never Vue 2 Options API or `Vue.component()`.

## Initialization Pattern

```vue
<script setup>
import { ref } from 'vue';
import { MbscEventcalendar } from '@mobiscroll/vue';

const events = ref([]);
const myView = { scheduler: { type: 'week' } };

function handleEventCreate(args) {
  // handle
}
</script>

<template>
  <MbscEventcalendar
    :data="events"
    :view="myView"
    @event-create="handleEventCreate"
  />
</template>
```

## Key Conventions

- Components are named exports with `Mbsc` prefix: `MbscEventcalendar`, `MbscDatepicker`,
  `MbscSelect`, `MbscPopup`.
- Prop binding uses `:prop` syntax: `:data="events"`, `:view="myView"`.
- Event binding uses `@event-name` syntax (kebab-case): `@event-create`, `@cell-click`,
  `@page-change`.
- State uses Vue reactivity: `ref()`, `reactive()`, `computed()`.
- TypeScript types are prefixed `Mbsc` (same as Angular): `MbscEventcalendarView`,
  `MbscCalendarEvent`.

## Anti-Patterns

| WRONG | RIGHT |
|:---|:---|
| Using Vue 2 Options API or `Vue.component()` | Use Vue 3 Composition API with `<script setup>` only |
| `<Eventcalendar />` without Mbsc prefix | `<MbscEventcalendar />` |
| `@onEventCreate` (React-style on-prefix in template) | `@event-create` (kebab-case, no on-prefix) |
| `import { Eventcalendar } from '@mobiscroll/react'` | `import { MbscEventcalendar } from '@mobiscroll/vue'` |
| `mobiscroll.eventcalendar('#el', {...})` imperative init | `<MbscEventcalendar :data="events" />` in template |
| Using `@mobiscroll/angular` or `@mobiscroll/javascript` | `@mobiscroll/vue` only |
| Using React `useState` / `useEffect` in Vue code | Vue 3 uses `ref()`, `computed()`, `onMounted()` etc. |

## Event Handling

```vue
<MbscEventcalendar @event-click="onEventClick" />
```

```typescript
function onEventClick(args) {
  console.log(args.event);  // the clicked event object
}
```

## Slot-Based Customization

```vue
<!-- v6: #schedulerEvent (v5: #scheduleEvent — deprecated in v6) -->
<MbscEventcalendar :data="events">
  <template #schedulerEvent="{ data }">
    <div class="custom-event">{{ data.title }}</div>
  </template>
</MbscEventcalendar>
```

> **v5 note:** `scheduleEvent` (without `r`) was the correct slot name in v5. In v6 it is
> deprecated — use `schedulerEvent` instead. The same rename applies to all `*Content`
> variants.

Always verify available slots via `mcp__mobiscroll__getComponentSchema`.


---
applyTo: "**"
name: mobiscroll-ui-react
description: |
  Mobiscroll React patterns — JSX components, render props, hooks, @mobiscroll/react
  imports. Invoked by mobiscroll-ui after framework detection.
  Do not auto-trigger — invoked by mobiscroll-ui only.
---

# Mobiscroll — React Patterns

> This skill is loaded by `mobiscroll-ui`. If you arrived here directly, invoke
> `mobiscroll-ui` first to run environment detection and the mandatory schema lookup.

Package: `@mobiscroll/react`
CSS import: `import '@mobiscroll/react/dist/css/mobiscroll.min.css'`

## Initialization Pattern

React uses JSX components with PascalCase names:

```jsx
import { useState, useMemo } from 'react';
import { Eventcalendar } from '@mobiscroll/react';

function MyCalendar() {
  const [events, setEvents] = useState([]);
  const myView = useMemo(() => ({ scheduler: { type: 'week' } }), []);

  return (
    <Eventcalendar
      data={events}
      view={myView}
      onEventCreate={(args) => { /* handle */ }}
    />
  );
}
```

## Key Conventions

- Components are named exports: `Eventcalendar`, `Datepicker`, `Select`, `Popup`.
- Props use camelCase: `data`, `view`, `selectedDate`, `onEventCreate`.
- Event handlers are props prefixed with `on`: `onEventCreate`, `onCellClick`, `onPageChange`.
- The `view` object should be memoized (via `useMemo`) to avoid unnecessary re-renders.
- State management uses standard React hooks (`useState`, `useEffect`, `useMemo`, `useCallback`).
- Controlled components: use `selectedDate` + `onSelectedDateChange` for controlled date state.

## Anti-Patterns

| WRONG | RIGHT |
|:---|:---|
| `import * as mobiscroll from '@mobiscroll/react'` | `import { Eventcalendar } from '@mobiscroll/react'` |
| `mobiscroll.eventcalendar('#el', {...})` imperative init | `<Eventcalendar data={events} view={myView} />` |
| Inline `view` object: `view={{ scheduler: { type: 'week' } }}` | Memoized: `const v = useMemo(() => ({...}), [])` |
| Using Angular `@Input()` or `@Output()` decorators | Use JSX props and `on*` event handlers |
| `@mobiscroll/javascript` or `@mobiscroll/angular` imports | `@mobiscroll/react` only |

## Event Handling

React event handlers receive an `args` object with event-specific data and an `inst`
reference to the component instance:

```jsx
<Eventcalendar
  onEventClick={(args) => {
    console.log(args.event);    // the clicked event object
    console.log(args.domEvent); // the original DOM event
  }}
/>
```

## Rendering Customization

Use render props (functions returning JSX) for custom rendering:

```jsx
{/* v6: renderSchedulerEvent (v5: renderScheduleEvent — deprecated in v6) */}
<Eventcalendar
  renderSchedulerEvent={(data) => (
    <div className="custom-event">{data.title}</div>
  )}
/>
```

> **v5 note:** `renderScheduleEvent` (without `r`) was the correct name in v5. In v6 it is
> deprecated — use `renderSchedulerEvent` instead. The same rename applies to all
> `*Content` variants.

Always verify available render props via `mcp__mobiscroll__getComponentSchema`.


---
applyTo: "**"
name: mobiscroll-ui-angular
description: |
  Mobiscroll Angular patterns — mbsc- directives, MbscModule, ng-template customization,
  @mobiscroll/angular imports. Invoked by mobiscroll-ui after framework detection.
  Do not auto-trigger — invoked by mobiscroll-ui only.
---

# Mobiscroll — Angular Patterns

> This skill is loaded by `mobiscroll-ui`. If you arrived here directly, invoke
> `mobiscroll-ui` first to run environment detection and the mandatory schema lookup.

Package: `@mobiscroll/angular`
CSS: Add to `angular.json` `styles` array — **NEVER** `import` in TypeScript or component files.

```json
// angular.json
"styles": [
  "node_modules/@mobiscroll/angular/dist/css/mobiscroll.min.css",
  "src/styles.scss"
]
```

Module import: `MbscModule` registered in your Angular module **or** standalone component imports (not both).

## Initialization Pattern

```typescript
// app.module.ts (NgModule app)
import { MbscModule } from '@mobiscroll/angular';

@NgModule({
  imports: [MbscModule]
})
export class AppModule {}
```

```typescript
// OR: standalone component
import { MbscModule } from '@mobiscroll/angular';
import { Component } from '@angular/core';

@Component({
  imports: [MbscModule],  // standalone — do NOT also add to @NgModule
  template: `...`
})
export class CalendarComponent {}
```

```html
<!-- component.html -->
<mbsc-eventcalendar
  [data]="events"
  [view]="myView"
  (onEventCreate)="handleEventCreate($event)"
></mbsc-eventcalendar>
```

```typescript
// component.ts
import { MbscEventcalendarView, MbscCalendarEvent } from '@mobiscroll/angular';

@Component({ ... })
export class CalendarComponent {
  events: MbscCalendarEvent[] = [];
  myView: MbscEventcalendarView = { scheduler: { type: 'week' } };

  handleEventCreate(args: any) { /* handle */ }
}
```

## Key Conventions

- Component selectors are prefixed `mbsc-`: `mbsc-eventcalendar`, `mbsc-datepicker`, `mbsc-select`, `mbsc-popup`.
- Property binding uses `[prop]` syntax: `[data]="events"`, `[view]="myView"`.
- Event binding uses `(onEventName)` syntax: `(onEventCreate)="handler($event)"`.
- TypeScript types are prefixed `Mbsc`: `MbscEventcalendarView`, `MbscCalendarEvent`.
- `MbscModule` goes in `@Component({ imports: [MbscModule] })` for standalone, or `@NgModule({ imports: [MbscModule] })` for NgModule apps — never both at once.

## Anti-Patterns

| WRONG | RIGHT |
|:---|:---|
| `<Eventcalendar />` React JSX | `<mbsc-eventcalendar>` Angular template |
| `import { Eventcalendar } from '@mobiscroll/react'` | `import { MbscModule } from '@mobiscroll/angular'` |
| `import '@mobiscroll/angular/dist/css/mobiscroll.min.css'` in TS | Use `angular.json` `styles` array |
| `@import '~@mobiscroll/angular/...'` in styles.scss | Use `angular.json` `styles` array |
| Adding `MbscModule` to both `@Component` and `@NgModule` | Standalone: `@Component({ imports: [MbscModule] })`. NgModule: `@NgModule({ imports: [MbscModule] })`. Not both. |
| `mobiscroll.eventcalendar('#el', {...})` imperative init | `<mbsc-eventcalendar [data]="events">` in template |
| `(click)="handler()"` for Mobiscroll events | `(onEventCreate)="handler($event)"` Mobiscroll events |
| Using `@mobiscroll/javascript` imports | `@mobiscroll/angular` only |

## Event Handling

```html
<mbsc-eventcalendar
  (onEventClick)="onEventClick($event)"
></mbsc-eventcalendar>
```

```typescript
onEventClick(args: any) {
  console.log(args.event);  // the clicked event object
}
```

## Template Customization

```html
<!-- v6: schedulerEventTemplate (v5: scheduleEventTemplate — deprecated in v6) -->
<mbsc-eventcalendar [schedulerEventTemplate]="customEvent">
  <ng-template #customEvent let-data>
    <div class="custom-event">{{ data.title }}</div>
  </ng-template>
</mbsc-eventcalendar>
```

> **v5 note:** `scheduleEventTemplate` (without `r`) was the correct name in v5. In v6 it is
> deprecated — use `schedulerEventTemplate` instead. The same rename applies to all
> `*Content` variants.

Always verify available template inputs via `mcp__mobiscroll__getComponentSchema`.
